# Dapr 1.7.5

### Fixes mDNS name resolver component not working on systems with IPv6 disabled

#### Problem

Users running Dapr in self-hosted mode and relying on the mDNS name resolver (the default when not running in Kubernetes) would encounter errors trying to perform service invocation if the system had IPv6 disabled.

### Impact

This issue impacts users who are:

- running Dapr in self-hosted mode, *and*
- using the default mDNS name resolver, *and*
- have disabled IPv6 on the operating system

#### Root cause

When initializing a zeroconf (mDNS) client, Dapr required using both IPv4 and IPv6, and failed if either one of the two protocols was disabled on the host system.

#### Solution

We have improved error handling so Dapr gracefully falls back to using IPv4 if binding to IPv6 fails.
